/** _Property decorator_, makes a property observable on every instance, with a read-only value shared across all instances taken from an (earlier OR later) call to `inject`, *until* the property is directly assigned to [requires ES5+ target] [decorator] */
export declare function injectable(target: Object, key: string, descriptor?: PropertyDescriptor): any;
/** Set given injectable observable properties (decorated with `injectable`) on *all* instances of given class and derived classes to the given values, except for instances where the property has been overwritten directly; may be called multiple times even with the same properties to redefine their injected value; returns an object with the previous injected values (for e.g. overriding an injected function that calls into the previously injected function) */
export declare function inject(targetClass: Function, spec: {
    [name: string]: any;
}): {};
